/**
 * CS 3725 - Assignment #2
 * By: Tim Oram (200529220)
 * Timing Diagram
 * ALU (D-Unit)
 */
package ca.mitmaro.mips.processor;

public class ALU {
	
	public enum State {IDLE, LOADED, OPERATING}
	
	// the number of cycles before this ALU is free
	private int cycles_remaining;
	
	private State state;
	
	public ALU() {
		this.state = State.IDLE;
	}
	
	public void set(int num_cycles) {
		this.cycles_remaining = num_cycles;
		this.state = State.LOADED;
	}
	
	public void cycle() {
		
		switch(this.state) {
			case LOADED: // loaded with data, will start calculating on the next cycle
				// 1 is an edge case and doesn't go into operating state
				if (this.cycles_remaining == 1) {
					this.state = State.IDLE;
				} else { 
					this.state = State.OPERATING;
				}
				break;
			case OPERATING:
				// decrease remaining cycles
				if (this.cycles_remaining > 1) {
					this.cycles_remaining--;
				}
				if (this.cycles_remaining == 1) { // last cycle, set to idle
					this.state = State.IDLE;
				}
				break;
		}
	}
	
	public boolean isIdle() {
		return this.state == State.IDLE;
	}
	
	public boolean isOperating() {
		return this.state == State.OPERATING;
	}
	
}
