/**
 * CS 3725 - Assignment #2
 * By: Tim Oram (200529220)
 * Timing Diagram
 * Diagram Writer - Writes a Timing Diagram
 */
package ca.mitmaro.mips;

import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;

public class DiagramWriter {
	
	private int cycle_count;

	public DiagramWriter(int cycle_count) {
		this.cycle_count = cycle_count;
	}
	
	public void write(LinkedList<Instruction> instructions) {
		int i;
		ArrayList<Operation> ops;
		
		Collections.sort(instructions);
		for (Instruction ins: instructions) {
			
			System.out.format("S(%3d): ", ins.getInstructionNumber());
			// instruction cycle start offset
			for (i = 0; i < ins.getStartCycle(); i++) {
				System.out.print("|   ");
			}
			
			// instruction run
			ops = ins.getOpeartions();
			for (i = 0; i < ops.size(); i++) {
				switch (ops.get(i)) {
					case ID:
						System.out.print("|I-U");
						break;
					case NOP:
						System.out.print("|   ");
						break;
					case ADD:
						System.out.print("| + ");
						break;
					case MULTI:
						System.out.print("| * ");
						break;
				}
			}
			// extra columns at end
			for (i = ins.getStartCycle() + ops.size(); i < this.cycle_count; i++) {
				System.out.print("|   ");
			}
			System.out.println("|");
		}
	}
	
}
