package ca.mitmaro.tomasulo.component;

import ca.mitmaro.tomasulo.Operation;

public class ReservationStation {
	
	private Operation operation;
	
	private boolean busy;
	
	 // actual values do not matter
	private boolean value_one;
	private boolean value_two;
	
	private ReservationStation tag_one;
	private ReservationStation tag_two;
	
	public ReservationStation(Operation op) {
		this.operation = op;
		this.reset();
	}
	
	public void setBusy() {
		this.busy = true;
	}
	
	public void setValueOne() {
		this.value_one = true;
	}
	
	public void setValueTwo() {
		this.value_two = true;
	}
	
	public void setTagOne(ReservationStation tag) {
		this.tag_one = tag;
	}
	
	public void setTagTwo(ReservationStation tag) {
		this.tag_two = tag;
	}
	
	public Operation getOperation() {
		return this.operation;
	}
	
	public void reset() {
		this.value_one = false;
		this.value_one = true;
		this.tag_one = null;
		this.tag_two = null;
		this.busy = false;
	}
	
	public boolean isFree() {
		return this.busy;
	}
	
	public void checkCopy(ReservationStation tag) {
		if (this.tag_one.equals(tag)) {
			this.setValueOne();
		}
		if (this.tag_two.equals(tag)) {
			this.setValueTwo();
		}
	}
	
	public boolean canExecute() {
		return this.value_one && this.value_two;
	}
	
}
