/**
 * CS3725 - Assignment #2
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a2;

import java.util.ArrayList;

import ca.mitmaro.cs3725.a2.program.Instruction;

/**
 * The program, a list of instructions
 */
public class Program extends ArrayList<Instruction> {

	private static final long serialVersionUID = -3117703962421028035L;
	
	// the program counter
	private int pc = 0;
	
	// adds a line to the program
	public void add(String line) {
		super.add(new Instruction(this.size(), line));
	}
	
	// gets the next instruction
	public Instruction next() {
		
		if (this.pc >= this.size()) {
			return null;
		}
		
		return this.get(this.pc++);
	}
	
	// has a next instruction
	public boolean hasNext() {
		return this.pc < this.size();
	}
	
	// resets the pc counter back to 0
	public void reset() {
		this.pc = 0;
	}

}
