/**
 * CS3725 - Assignment #2
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a2.gui;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.Document;

public class Editor extends JPanel {
	
	private static final long serialVersionUID = 3372706082374558766L;
	
	public final JButton bOpen;
	public final JButton bSave;
	public final JButton bClear;
	public final JButton bRun;
	
	public final JTextArea editor;
	public final Document editorDocument;
	
	public Editor() {
		this.bOpen = new JButton("Open");
		this.bClear = new JButton("Clear");
		this.bRun = new JButton("Run");
		this.bSave = new JButton("Save");
		this.editor = new JTextArea();
		this.editorDocument = this.editor.getDocument();
		
		this.initComponents();
	}
	
	public void setupEvents(Events events) {
		this.bOpen.addActionListener(events.programLoad);
		this.bRun.addActionListener(events.machineRun);
		this.bClear.addActionListener(events.editorClear);
		this.bSave.addActionListener(events.programSave);
		this.editorDocument.addDocumentListener(events.editorChanged);
	}
	
	private void initComponents() {
		// this frame
		this.setBorder(BorderFactory.createTitledBorder("Editor"));
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		// buttons frame
		JPanel buttons = new JPanel();
		buttons.setLayout(new FlowLayout(FlowLayout.RIGHT, 0, 0));
		buttons.add(this.bOpen);
		buttons.add(this.bSave);
		buttons.add(this.bClear);
		buttons.add(this.bRun);
		buttons.setMaximumSize(new Dimension(Integer.MAX_VALUE, buttons.getPreferredSize().height));
		this.add(buttons);
		
		// editor area
		this.editor.setFont(new Font("Monospaced", Font.PLAIN, 18 ));
		JScrollPane scroll = new JScrollPane(
			this.editor,
			JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
			JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED
		);
		
		this.add(scroll);
	}
	
}
