/**
 * CS3725 - Assignment #2
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a2.gui;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSplitPane;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class Window extends javax.swing.JFrame {

	private static final long serialVersionUID = -5983986739701452596L;

	public final Graph graph;
	public final Options options;
	public final Editor editor;
	
	public Window() {
		this.graph = new Graph();
		this.options = new Options();
		this.editor = new Editor();
	}
	
	public void setupEvents(Events events) {
		this.editor.setupEvents(events);
		this.graph.setupEvents(events);
	}
	
	private void initComponents() {
		
		CellConstraints cc = new CellConstraints();
		JPanel top = new JPanel(new FormLayout("fill:pref:grow, 10px, left:pref", "fill:pref:grow"));
		top.add(this.editor, cc.xy(1, 1));
		top.add(this.options, cc.xy(3, 1));
		
		JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT, top, this.graph);
		
		split.setResizeWeight(0.5);
		split.setContinuousLayout(true);
		
		this.add(split);
		
	}
	
	public void initLookAndFeel() {
		this.setTitle("CS 3725 Assignment 2");
	}
	
	public void run() {
		
		this.initLookAndFeel();

		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		this.initComponents();
		
		this.pack();
		this.setVisible(true);
		this.setExtendedState(this.getExtendedState() | JFrame.MAXIMIZED_BOTH);
	}
	
}
