/**
 * CS3725 - Assignment #2
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a2.machine.component;

public class Register implements Component {

	protected int number;

	// number of instructions with a hold
	protected int heldInput;
	protected int heldOutput;
	
	public Register(int number) {
		this.number = number;
		this.reset();
	}

	public void holdInput() {
		this.heldInput++;
	}

	public void holdOutput() {
		this.heldOutput++;
	}

	public void releaseInput() {
		if (this.heldInput > 0) {
			this.heldInput--;
		}
	}
	
	public void releaseOutput() {
		if (this.heldOutput > 0) {
			this.heldOutput--;
		}
	}
	
	public boolean isHeldAsInput() {
		return this.heldInput > 0;
	}

	public boolean isHeldAsOutput() {
		return this.heldOutput > 0;
	}
	
	@Override
	public void reset() {
		this.heldInput = 0;
		this.heldOutput = 0;
	}

}
