/**
 * CS3725 - Assignment #3
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a3.gui;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.layout.FormLayout;

public class Options extends JPanel{

	private static final long serialVersionUID = 5784969387953914363L;

	public final SpinnerNumberModel addersModel;
	public final SpinnerNumberModel adderCyclesModel;
	public final SpinnerNumberModel multipliersModel;
	public final SpinnerNumberModel multiplierCyclesModel;
	public final SpinnerNumberModel iuCyclesModel;
	public final SpinnerNumberModel registersModel;
	public final SpinnerNumberModel cycleTimeModel;

	public final JSpinner adders;
	public final JSpinner adderCycles;
	public final JSpinner multipliers;
	public final JSpinner multiplierCycles;
	public final JSpinner registers;
	public final JSpinner iuCycles;
	public final JSpinner cycleTime;
	
	public Options() {
		this.addersModel = new SpinnerNumberModel(4, 1, Integer.MAX_VALUE, 1);
		this.adderCyclesModel = new SpinnerNumberModel(4, 1, Integer.MAX_VALUE, 1);
		this.multipliersModel = new SpinnerNumberModel(2, 1, Integer.MAX_VALUE, 1);
		this.multiplierCyclesModel = new SpinnerNumberModel(6, 1, Integer.MAX_VALUE, 1);
		this.iuCyclesModel = new SpinnerNumberModel(1, 1, Integer.MAX_VALUE, 1);
		this.registersModel = new SpinnerNumberModel(20, 1, Integer.MAX_VALUE, 1);
		this.cycleTimeModel = new SpinnerNumberModel(500, 0, Integer.MAX_VALUE, 100);
		
		this.adders = new JSpinner(this.addersModel);
		this.adderCycles = new JSpinner(this.adderCyclesModel);
		this.multipliers = new JSpinner(this.multipliersModel);
		this.multiplierCycles = new JSpinner(this.multiplierCyclesModel);
		this.registers = new JSpinner(this.registersModel);
		this.iuCycles = new JSpinner(this.iuCyclesModel);
		this.cycleTime = new JSpinner(this.cycleTimeModel);
		
		this.initComponents();
	}
	
	private void initComponents() {
		// this frame
		this.setBorder(BorderFactory.createTitledBorder("Options"));
		
		FormLayout layout = new FormLayout(
			"right:pref, 10px, left:pref:grow", ""
		);
		
		this.setLayout(layout);
		DefaultFormBuilder builder = new DefaultFormBuilder(layout, this);

		builder.append("Adders:", this.adders);
		builder.append("Adder Cycles:", this.adderCycles);
		builder.append("Multipliers:", this.multipliers);
		builder.append("Multiplier Cycles:", this.multiplierCycles);
		builder.append("IU Cycles:", this.iuCycles);
		builder.append("Registers:", this.registers);
		builder.append("Cycle Time (ms):", this.cycleTime);
		
	}
	

}
