/**
 * CS3725 - Assignment #3
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a3.machine;

import java.util.ArrayList;

import ca.mitmaro.cs3725.a3.machine.component.OperableComponent;
import ca.mitmaro.cs3725.a3.program.Instruction;
import ca.mitmaro.cs3725.a3.program.Operation;


// simple cycle operation class for passing data to the GUI
public final class CycleOperations extends ArrayList<CycleOperations.Entry> {
	
	private static final long serialVersionUID = -5508480135574645901L;
	
	public final static class Entry {
		public final Instruction instruction;
		public final Operation operation;
		
		public Entry(Instruction instruction, Operation operation) {
			this.instruction = instruction;
			this.operation = operation;
		}
		
	}
	
	public void addOperation(OperableComponent op) {
		this.add(new Entry(op.getInstruction(), new Operation(op.getOperation())));
	}
	
}