/**
 * CS3725 - Assignment #3
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a3.machine.scoreboard;

import ca.mitmaro.cs3725.a3.machine.component.DUnit;

public class DUnitStatus {
	
	public final DUnit dunit;
	
	private DUnit rsDUnit;
	private DUnit rtDUnit;
	
	public DUnitStatus(DUnit dunit) {
		this.dunit = dunit;
	}
	
	public void setSourceDUnits(DUnit rs, DUnit rt) {
		this.rsDUnit = rs;
		this.rtDUnit = rt;
	}
	
	public DUnit getRSDUnit() {
		return this.rsDUnit;
	}
	
	public DUnit getRTDUnit() {
		return this.rtDUnit;
	}

	public boolean rsReady() {
		return this.rsDUnit == null;
	}

	public boolean rtReady() {
		return this.rtDUnit == null;
	}
	
	public boolean isBusy() {
		return !this.dunit.isFree();
	}
	
	
	
}