/**
 * CS3725 - Assignment #3
 * Tim Oram (200529220)
 * 
 * License:
 * The MIT License (MIT) Copyright (c) 2013 Tim Oram
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
package ca.mitmaro.cs3725.a3.machine.scoreboard;

import ca.mitmaro.cs3725.a3.machine.State;
import ca.mitmaro.cs3725.a3.program.Instruction;

public class InstructionStatus {

	public final Instruction instruction;
	
	private State state;
	
	public InstructionStatus(Instruction instruction) {
		this.instruction = instruction;
		this.state = State.ISSUING;
	}

	public void read() {
		this.state = State.READINGOP;
	}

	public void execute() {
		this.state = State.EXECUTING;
	}

	public void write() {
		this.state = State.WRITING;
	}

	public void done() {
		this.state = State.DONE;
	}
	
	public boolean isIssuing() {
		return this.state == State.ISSUING;
	}
	
	public boolean isReading() {
		return this.state == State.READINGOP;
	}
	
	public boolean isExecuting() {
		return this.state == State.EXECUTING;
	}
	
	public boolean isWriting() {
		return this.state == State.WRITING;
	}

	public boolean isDone() {
		return this.state == State.DONE;
	}
	
	public boolean isInvalid() {
		return this.state == State.INVALID;
	}
	
}